package betterwithmods.common.blocks;

import betterwithmods.common.BWMBlocks;
import betterwithmods.util.ColorUtils;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.EnumDyeColor;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.Random;

import static net.minecraft.util.EnumFacing.UP;

public class BlockCandle extends BWMBlock {

    public BlockCandle() {
        super(Material.field_151578_c);
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(ColorUtils.COLOR, EnumDyeColor.WHITE));
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, ColorUtils.COLOR);
    }

    public static ItemStack getStack(EnumDyeColor type) {
        return new ItemStack(BWMBlocks.CANDLE, 1, type.func_176765_a());
    }

    @SideOnly(Side.CLIENT)
    public void func_180655_c(IBlockState stateIn, World worldIn, BlockPos pos, Random rand) {
        double d0 = (double) pos.func_177958_n() + 0.5D;
        double d1 = (double) pos.func_177956_o() + 0.7D;
        double d2 = (double) pos.func_177952_p() + 0.5D;
        worldIn.func_175688_a(EnumParticleTypes.SMOKE_NORMAL, d0 + 0.27D * (double) UP.func_82601_c(), d1 + 0.22D, d2 + 0.27D * (double) UP.func_82599_e(), 0.0D, 0.0D, 0.0D);
        worldIn.func_175688_a(EnumParticleTypes.FLAME, d0 + 0.27D * (double) UP.func_82601_c(), d1 + 0.22D, d2 + 0.27D * (double) UP.func_82599_e(), 0.0D, 0.0D, 0.0D);
    }

    @Override

    public void func_149666_a(CreativeTabs itemIn, NonNullList<ItemStack> items) {
        for (EnumDyeColor color : EnumDyeColor.values())
            items.add(getStack(color));
        super.func_149666_a(itemIn, items);
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        return this.func_176223_P().func_177226_a(ColorUtils.COLOR, EnumDyeColor.func_176764_b(meta));
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(ColorUtils.COLOR).func_176765_a();
    }


    @Override
    public boolean func_176196_c(World worldIn, BlockPos pos) {
        return worldIn.isSideSolid(pos.func_177977_b(), UP);
    }

    @Override
    public int getLightValue(IBlockState state, IBlockAccess world, BlockPos pos) {
        return 15;
    }
}
