package betterwithmods.common.world.gen.feature;

import betterwithmods.common.blocks.BlockStump;
import net.minecraft.block.BlockNewLog;
import net.minecraft.block.BlockPlanks;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenCanopyTree;

import java.util.Random;

/**
 * Hardcore Stumping tree.
 *
 * @author Koward
 */
public class WorldGenCanopyTreeWithStump extends WorldGenCanopyTree {
    private static final IBlockState LOG = Blocks.field_150363_s.func_176223_P().func_177226_a(BlockNewLog.field_176300_b, BlockPlanks.EnumType.DARK_OAK);

    public WorldGenCanopyTreeWithStump(boolean notify) {
        super(notify);
    }

    @Override
    public boolean func_180709_b(World worldIn, Random rand, BlockPos position) {
        boolean vanillaResult = super.func_180709_b(worldIn, rand, position);
        if (vanillaResult) {
            attemptToPlaceStump(worldIn, position);
            attemptToPlaceStump(worldIn, position.func_177982_a(0, 0, 1));
            attemptToPlaceStump(worldIn, position.func_177982_a(1, 0, 0));
            attemptToPlaceStump(worldIn, position.func_177982_a(1, 0, 1));
        }
        return vanillaResult;
    }

    private void attemptToPlaceStump(World worldIn, BlockPos position) {
        if (BlockStump.canPlaceStump(worldIn, position)) {
            IBlockState stump = BlockStump.getStump(LOG);
            if (stump == null) return;
            this.func_175903_a(worldIn, position, stump);
        }
    }
}
