package betterwithmods.module.hardcore.creatures;

import betterwithmods.common.damagesource.BWDamageSource;
import betterwithmods.common.items.tools.ItemSoulforgeArmor;
import betterwithmods.module.Feature;
import betterwithmods.network.NetworkHandler;
import betterwithmods.util.InvUtils;
import betterwithmods.util.player.PlayerHelper;
import com.google.common.eventbus.Subscribe;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.passive.EntitySquid;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.SoundEvents;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.network.play.server.SPacketSetPassengers;
import net.minecraft.util.DamageSource;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.SoundEvent;
import net.minecraft.util.math.MathHelper;
import net.minecraftforge.event.entity.EntityMountEvent;
import net.minecraftforge.event.entity.living.LivingEvent;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class HCSquid extends Feature {


	@Override
	public String getFeatureDescription() {
		return "Fear the squid...";
	}

	@Override
	public boolean hasSubscriptions() {
		return true;
	}

	@SubscribeEvent
	public void onEntityTick(LivingEvent.LivingUpdateEvent event) {

		if (event.getEntityLiving() instanceof EntitySquid) {
			EntitySquid squid = (EntitySquid) event.getEntityLiving();
			if (squid.func_184218_aH() && squid.func_184187_bx() instanceof EntityLivingBase) {
				EntityLivingBase mount = (EntityLivingBase) squid.func_184187_bx();

				//Attack if not wearing a SFS helmet
				if(!PlayerHelper.hasPart(mount, EntityEquipmentSlot.HEAD, ItemSoulforgeArmor.class)) {
					if(mount.field_70170_p.field_73012_v.nextInt(5)==0)
						mount.field_70170_p.func_184133_a(null,mount.func_180425_c(), SoundEvents.field_187833_fS, SoundCategory.HOSTILE,0.5f,1);
					mount.func_70097_a(BWDamageSource.squid, 1);
				}

				float f1 = MathHelper.func_76133_a(squid.field_70159_w * squid.field_70159_w + squid.field_70179_y * squid.field_70179_y);
				squid.field_70861_d += (-((float) MathHelper.func_181159_b((double) f1, squid.field_70181_x)) * (180F / (float) Math.PI) - squid.field_70861_d) * 0.5F;
				squid.func_70050_g(300);
			}
		}
	}

	@SubscribeEvent
	public void onEntityCollide(PlayerInteractEvent.EntityInteractSpecific event) {
		if (event.getWorld().field_72995_K)
			return;
		if (event.getTarget() instanceof EntitySquid) {
			EntityPlayer player = event.getEntityPlayer();
			if (!player.func_184207_aI() && event.getTarget().func_184205_a(player, true)) {
				((EntitySquid) event.getTarget()).func_94061_f(true);
				if (player instanceof EntityPlayerMP) {
					NetworkHandler.sendPacket(player, new SPacketSetPassengers(player));
				}
			}
		}
	}



}
